/*********************************************************
 *
 * Menu bar for PV Merlin
 *
 * Copyright (c) 2001 Marcin Wolinski
 *
 *********************************************************/

#include	"modeldef.h"
#include	"menubar.h"

/*** Merlin Main Menu ***/

/* 'Edit' pulldown: */
word	MPdEdt[] ={
  20,		/* Cut */
  21,		/* Copy */
  22,		/* Paste */
  14,		/* New */
  49,		/* List */
  477,		/* Save */
  23,       /* Delete */
  PDNTBLEND,
};

/* 'Options' pulldown: */
word	MPdOpt[] = {
  437,          /* ce: Set up parameters */
  65,           /* ce: keyboard */
  478,          /* ce: Screen copy */
  PDNTBLEND,
};


/*** List-Menu ***/

/* 'Edit' pulldown: */
word ListPdEdt[] ={
  16,   /* Search */
  17,   /* View */
  PDNTBLEND
};

/* 'Options' pulldown: */
word ListPdOpt[] ={
  PDNTBLEND
};

/*** general-menu ***/

/* 'System' pulldown: */
#define PDWN_SYS_DTTM	PULLDOWN_SYSTEM | 0x0001 /* Set_date/time */
#define PDWN_SYS_SOUND	PULLDOWN_SYSTEM | 0x0002 /* Sound */
#define PDWN_SYS_FORMT	PULLDOWN_SYSTEM | 0x0004 /* Format */
#define PDWN_SYS_CAPCT	PULLDOWN_SYSTEM | 0x0008 /* Capacity */
#define PDWN_SYS_MMANE	PULLDOWN_SYSTEM | 0x0010 /* Memory management */
#define PDWN_SYS_CNTRS	PULLDOWN_SYSTEM | 0x0020 /* Contrast */
#define PDWN_SYS_TPA	PULLDOWN_SYSTEM | 0x0040 /* Touch_Panel_Alignment*/

word	MPdSys[] = {
			38,			/* Set_date/time		*/
			33,			/* Sound				*/
			39,			/* Format				*/
			34,			/* Capacity				*/
			35,			/* Memory_management	*/
/*			36,			/* Language				*/
			37,			/* Contrast				*/
			40,			/* Touch_Panel_Alignment*/
/*			41,			/* Data_communication	*/
			PDNTBLEND,
		};

static void PdwnFncSys(word sel);

SLW_TBL ktb_s[3] = {{312,0},{313,1},{314,2}};


/* Main menubar: */
word merlinmenubar() {
  word sel;
  LibPullDownInit(MPdEdt,MPdSys,MPdOpt);		/* MenuBAR Init */

  sel = LibPullDown();		/* PullDownMenu */
  if(sel & PULLDOWN_SYSTEM) {
    PdwnFncSys(sel);
    return (PDWN_NONE);
  }
  return sel;
}

/* List menubar: */
word listmenubar() {
  word sel;
  LibPullDownInit(ListPdEdt,MPdSys,ListPdOpt);		/* MenuBAR Init */

  sel = LibPullDown();		/* PullDownMenu */
  if(sel & PULLDOWN_SYSTEM) {
    PdwnFncSys(sel);
    return (PDWN_NONE);
  }
  return sel;
}

/* Fairly generic 'System' pulldown: */
static void PdwnFncSys(word sel)
{
  /* bool jdg = FALSE; */
  switch(sel){
    
  case PDWN_SYS_DTTM:		/* Set_date/time		*/
    LibFuncDateTime();
    break;
    
  case PDWN_SYS_SOUND:	/* Sound				*/
    LibFuncSound(0);
    break;

  case PDWN_SYS_FORMT:	/* Format				*/
    LibFuncFormat();
    break;
    
  case PDWN_SYS_CAPCT:	/* Capacity				*/
    LibFuncCapa();
    break;

  case PDWN_SYS_MMANE:	/* Memory_management	*/
    LibFuncMemoryManagement();
    break;

    /*		case PDWN_SYS_LANG:		/* Language */
    /*			if(LibFuncLang()==TRUE){ */
    /*				jdg = TRUE; */
    /*			} */
    /*			break; */
    
  case PDWN_SYS_CNTRS:	/* Contrast */
    LibFuncContrast();
    break;

  case PDWN_SYS_TPA:		/* Touch_Panel_Alignment*/
    LibFuncDigitizer();
    break;

  default:
    break;
  }
  /*  return(jdg); */
}
