/* permshared.h
   2004/05/21 J. Steingraeber

   Permanent storage of PV applets' data.

   Crude hack to allow usage of SHARED

   Based on Marcin Wolinski's permanent.c
   Based on CASIO's 16-puzzle example.  

*/
#include "modeldef.h"

#include "permanent.h"

/* peephole the size of params for LibFileReadEx */
#include "params.h"
#define PARAMBLOCKS ((sizeof(s_pvmerlin_permanent_data)+FILE_BLOCK_SIZE-1)/FILE_BLOCK_SIZE)

static struct _f
{
  FILE_INFO fi;
  FILE_BUF fb;
  unsigned char dummy[FILE_BLOCK_SIZE]; /* avoid overflow */
} f;
static byte entry_cond; /* Is everything OK? */

bool openShared()
{
  return LibGetAllEntry("SHARED",&f.fb.fsb_main_entry_,&f.fb.fsb_sub_entry_);
}

bool permanentInit( const char* fname, void **data, word dlen ) {
  int l = strlen(fname) + 1;
  
  *data = &f.fb.fbuf.bin.bin_buf[l];
  entry_cond = FALSE;
  memset(&f,0,sizeof(f));
  f.fb.fsb_main_entry_ = 0xA0; /* Add-In binary data */
  f.fb.fsb_scrt_info_  = IMB_FILE_OPEN_MODE;	/* Open Mode */
  f.fi.fp = -1;		/* first Data */
  f.fi.kind = FILE_KIND_BIN;
  
  if (!openShared()) { /* File does not exist, yet */
    if (!LibSubEntrySave("SHARED",&f.fb.fsb_sub_entry_)) { /* create file */
      f.fb.fsb_main_entry_ = f.fb.fsb_sub_entry_ = 0xFF;
      return(FALSE);
    }
    openShared();
  }

  entry_cond = TRUE; /* we have SHARED */
  
      /* now find record fname */
  while (LibFileFindNext(&f.fb,&f.fi,0)
         && LibFileReadEx(&f.fb,&f.fi,PARAMBLOCKS))
  {
    if (!strcmp(f.fb.fbuf.bin.bin_buf,fname)) {
      return(TRUE);
    }
  }

      /* record not found, prepare for writing a new one */
  f.fi.fp = -1;
  f.fi.kind = FILE_KIND_BIN;

  f.fb.fbuf.bin.char_num = dlen + l;
  strcpy(f.fb.fbuf.bin.bin_buf,fname);
  
  return(FALSE);
}

void permanentSave() {
  if (!entry_cond)
    return;
  
  if (!LibFileWrite(&f.fb, &f.fi)) {             /* Saving data */
    LibErrorDisp(FlashStatus);				/* Error Disp */
  }
}
