/*********************************************************
 * event.h
 *
 * Copyright (c) Stefan Hellkvist
 *********************************************************/

#ifndef EVENT_H
#define EVENT_H

#include "modeldef.h"

#include "wizard.h"

#include "util.h"

#define DRAG      0
#define PEN_UP    1
#define PEN_DOWN  2

typedef struct PenEvent
{
    int x, y;
} PenEvent;

/*ce typedef enum { SINGLE_STROKE, MULTIPLE_STROKE } MODE; */


/*ce 
extern MODE mode;
void setMode( SM_MODE m ); */


#define OBJ_MERLIN 0x8001 /* can be changed via tch in mlInit. This serves just as a suggested common constant */

#define ML_WIDTH    142 /* 141 */

/*ce-kb #define ML_HEIGHT   144*/
#define ML_ACTMASK  (ACT_ICON|ACT_BREAK|ACT_DOWN_IN|ACT_DOWN) /*(ACT_ICON|ACT_DOWN|ACT_DOWN_IN)  /* (ACT_ICON|ACT_MOVE) |ACT_MOVE */

/*#define MERLIN_TCH(x,y,obj)			   \
	x, y, (x) + ML_WIDTH-1, (y) + ML_HEIGHT-1, \
	ML_ACTMASK, obj, 0
*/

int  mlHandleEvent(TCHSTS *);
void mlPaint();

/*ce4 replaced void mlInit(TCHTBL far *tch, bool ink); */
void mlInit(TCHTBL FAR *tch, bool ink, word underlyingObj, bool allowExtMode); /* , word myObj); */

void dropInputPattern();

/*ce*/
typedef enum { ALPHA_MODE, ALPHA_EXT_MODE, NUMERAL_MODE, NUMERAL_EXT_MODE } t_char_mode;
typedef enum { LOWERCASE_MODE, SHIFTED_MODE, CAPSLOCK_MODE } t_shift_mode;
/* SHIFT_MODE always implies ALPHA_MODE, CAPSLOCK_MODE does not */

void setCharMode( t_char_mode cm );
void setShiftMode( t_shift_mode sm );
t_char_mode getCharMode();
t_shift_mode getShiftMode();

unsigned char changeToNextMode( unsigned char c ); /* the 'state machine' for the modes */

#define MAX_PATTERN_LENGTH 299
/*ce longer patterns are not allowed. Although pattern.c allows dynamic growth of 
patterns (which is used if INITIAL length is exceeded) we stop growing at some point, 
because it simply would not make much sense (and we will run out of memory anyway) */
#define INITIAL_PATTERN_LENGTH 100



/********** ce4 new ***********/

void mlSetPassTimeThreshold(byte pval);

#define MERLIN_PENSTROKE 0xffff         /* Event was handled by Merlin. Merlin is waiting for more pen movements */
#define MERLIN_PASSTHROUGH 0xfffe       /* Event should be handeled by method caller */
#define MERLIN_PASSTHROUGH_START 0xfffd /* Event should be handeled by method caller + pen was lifted or Merlin area was left */
#define MERLIN_PASSTHROUGH_END 0xfffc   /* Event should be handeled by method caller + pen was lifted or Merlin area was left */
#define MERLIN_IGNORE 0xfffb            /* Event was 'eaten' by Merlin and ignored */

/*ceV4 aus PV.c verlegt */
typedef enum { PVM_IDLE_MODE, PVM_PENSTART_MODE, PVM_WRITE_MODE, PVM_TXTCURSOR_MODE } t_pvm_mode;

t_pvm_mode getEventMode();

/* returns recognized character or any of the three MERLIN_... constants */
int mlHandleOrPassEvent(TCHSTS *ptsts);

void mlBackupConfig();
void mlRestoreConfig();

#endif



